#!/usr/bin/env node
var fs = require('fs');
var sys = require('sys');
var parser = require('uglify-js').parser;

function findStrings(item) {
    var strings = {};
    function iter(list) {
        try {
            if (typeof list == 'string') { return; }
            if (list[0] == 'string') {
                var value = list[1];
                if (strings.hasOwnProperty(value)) {
                    strings[value]++;
                } else {
                    strings[value] = 1;
                }
                return;
            } else {
                for (var i=0; i<list.length; i++) {
                    iter(list[i]);
                }
            }
        } catch (e) {}
    }
    iter(item);
    return strings;
}

function printReport(strings) {
    for (string in strings) {
        if (strings.hasOwnProperty(string)) {
            var count = strings[string];
            if (count > 1) {
                sys.puts('Found ' + count + ' instance(s) of "' + string + '"');
            }
        }
    }
}

var files = [];
for (var i=1; i<process.argv.length; i++) {
    var file = process.argv[i];
    if (file.indexOf('skillet') == -1) {
        files.push(file);
    }
}

for (var i=0; i<files.length; i++) {
    var file = files[i];
    fs.readFile(file, function(err, data) {
        sys.puts('Reading in ' + file);
        var ast = parser.parse(data.toString());
        printReport(findStrings(ast));
        sys.puts('');
    });
}
